/* burneye cryptographic layer 1 & 2 cracker
 * by [ByteRage] / UNF
 *
 * (C) Copyright UNF security, 2002
 * All Rights Reserved
 */

#define FIXUP 0
/* set FIXUP to -1 to fix 7350wurm_0.3.3,
   and run burncrack with -n switch
   don't forget to set it back to 0 when you're done :) */

#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "obfuscate.h"
#include "sha1hash.h"
#include "rc4check.h"

/* the following information is obtained from the burneye'd ELF file
   (crypto layer 1 must be removed first) */
unsigned char xormagic[20] = "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
                             "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
unsigned long crypted = 0x00000000;

/* filenames */
char * infile = "";
char * intermediatefile = "./burneye.dec";
char * outfile = "";

unsigned long timestart, timeend;
struct timeval todstart, todend;
struct timezone dummy;
double starttime, endtime;

unsigned char pwd[64] =
"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
unsigned long pwdlen;
unsigned char digest[20];

unsigned long cryptedstart;
unsigned long cryptedlength;
unsigned long checksum;

char startcharset = 'a';
char endcharset = 'z';

/* burneye crypto layer 1 (obfuscation layer) removal routine */
void
removelayer1(char *filename)
{
        FILE *fh;
	unsigned char *elffile;
        unsigned long l = 0, m, fnd, filesize;
	char sign[] = "TEEE burneye - TESO ELF Encryption Engine";
	printf("---[ removing layer 1 (obfuscation layer)\n");
	if ((fh = fopen(filename, "rb")) == 0) {
		printf("failed to open file %s\n", filename);
	        exit(EXIT_FAILURE);
	}
	fseek(fh, 0, SEEK_END);
	filesize = ftell(fh);
	if ((elffile = (char *)malloc(filesize)) == 0) {
		printf("failed to allocate memory\n");
	        exit(EXIT_FAILURE);
	}
	fseek(fh, SEEK_SET, 0);
	fread(elffile, 1, filesize, fh);
	fclose(fh);
	fnd=0;
	for(l = 0; l < filesize-sizeof(sign)+1; l++)
		if (memcmp(&elffile[l], sign, sizeof(sign)-1) == 0) {
			fnd=1;
			break;
		}
	if (fnd) {
		printf("burneye signature found @ %08lX\n", l);
		printf("obfuscation layer (layer 1) decryption key : %08lX\n",
			*(unsigned long *)&elffile[l-8]);    
		printf("length : %08lX\n start : %08lX\n",
			*(unsigned long *)&elffile[l-12],
			*(unsigned long *)&elffile[l-4]);    
	        if ((*(unsigned long *)&elffile[l-4] & 0xFFFF) < filesize) {
			m=*(unsigned long *)&elffile[l-4] & 0xFFFF;
			while((m>0) && (elffile[m] != 0xE8))
				m--;
			m+=5;
			obfuscate(elffile + m,
				elffile + m,
				*(unsigned long *)&elffile[l-12],
				*(unsigned long *)&elffile[l-8]);
		}
        	/* now we can set the key to 0 */
		elffile[l-8] = 0;
		elffile[l-7] = 0;
		elffile[l-6] = 0;
		elffile[l-5] = 0;
	} else {
		printf("burneye signature not found!\n");	
		exit(EXIT_FAILURE);
	}
	if ((fh = fopen(intermediatefile, "w+b")) == 0) {
	    printf("failed to open file %s\n", intermediatefile);
	    exit(EXIT_FAILURE);
	}
	fwrite(elffile, 1, filesize, fh);
	fclose(fh);
	free(elffile);
}

/* the RC4 routines may be used to decrypt the entire wrapped binary */

typedef struct rc4_key
{
	unsigned char state[256];
	unsigned char x;
	unsigned char y;
} rc4_key;

#define swap_byte(x,y) t = *(x); *(x) = *(y); *(y) = t

void
prepare_key(unsigned char *key_data_ptr, int key_data_len, rc4_key *key)
{
	unsigned char t;
	unsigned char index1;
	unsigned char index2;
	unsigned char *state;
	short counter;
  	state = &key->state[0];
	for(counter = 0; counter < 256; counter++)
		state[counter] = counter;
	key->x = 0;
	key->y = 0;
	index1 = 0;
	index2 = 0;
	for(counter = 0; counter < 256; counter++) {
		index2 = (key_data_ptr[index1] + state[counter] + index2) % 256;
		swap_byte(&state[counter], &state[index2]);
		index1 = (index1 + 1) % key_data_len;
	}
}

void
rc4(unsigned char *buffer_ptr, int buffer_len, rc4_key *key)
{
	unsigned char t;
	unsigned char x;
	unsigned char y;
	unsigned char *state;
	unsigned char xorIndex;
	unsigned long counter;
	x = key->x;
	y = key->y;
	state = &key->state[0];
	for(counter = 0; counter < buffer_len; counter++) {
		x = (x + 1) % 256;
		y = (state[x] + y) % 256;
		swap_byte(&state[x], &state[y]);
		xorIndex = (state[x] + state[y]) % 256;
		buffer_ptr[counter] ^= state[xorIndex];
	}
	key->x = x;
	key->y = y;
}

/* rc4check has been implemented in assembler and is commented out
   it is left here as a platform independant C version */
/*
unsigned long
rc4check(unsigned char *key_data_ptr, unsigned long crypted)
{
	unsigned char t;
	unsigned char y;
	unsigned char index1;
	unsigned char index2;
	unsigned char state[] = {
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,
	};
	unsigned short counter;
	index1 = 0;
	index2 = 0;
	for(counter = 0; counter < 256; counter++) {
		index2 = (unsigned char)(key_data_ptr[index1] + state[counter] + index2);
		swap_byte(&state[counter], &state[index2]);
		if (index1 < 19)
			index1++;
		else
			index1 = 0;
	}
	y = state[1];
	//swap_byte(&state[1], &state[y]);
	state[1] = state[y];
	state[y] = y;
	if (((crypted & 0xff) ^ state[(state[1] + state[y]) & 0xff]) == 0) {
		y = (unsigned char)(state[2] + y);
		swap_byte(&state[2], &state[y]);
		if ((((crypted >> 8) & 0xff) ^ state[(unsigned char)(state[2] + state[y])]) == 0) {
			y = (unsigned char)(state[3] + y);
			swap_byte(&state[3], &state[y]);
			if ((((crypted >> 16) & 0xff) ^ state[(unsigned char)(state[3] + state[y])]) == 0) {
				y = (unsigned char)(state[4] + y);
				// swap_byte(&state[4], &state[y]);
				if (((crypted >> 24) ^ state[(unsigned char)(state[4] + state[y])]) == 0)
					return 0;
			}
		}
	}
	return -1;
}
*/

/* perform a sanity check on the entire decrypted wrapped binary
   (this is the check performed by burneye itself) */
unsigned long
sanitycheck(char *infile)
{
	unsigned char checkhash[20] =
	"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
	"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";	
	FILE *fh;
	rc4_key key;    
	char * elffile;

	printf("performing sanity check...\n");
	if ((fh = fopen(infile, "rb")) == 0) {
		printf("failed to open file %s\n", infile);
	        exit(EXIT_FAILURE);
	}
	if ((elffile = (char *)malloc(cryptedlength)) == 0) {
		printf("failed to allocate memory\n");
	        exit(EXIT_FAILURE);
	}
	fseek(fh, cryptedstart, SEEK_SET);
	fread(elffile, 1, cryptedlength, fh);
	fclose(fh);
	if (crypted) {
    		prepare_key(digest, 20, &key);
		rc4(elffile, cryptedlength, &key);
	}
	SHA1Hash(elffile, cryptedlength, checkhash);
	free(elffile);
	printf("found checksum      : 0x%08lX\n", *(unsigned long *)&checkhash);
	if (checksum != *(unsigned long *)&checkhash) {
		printf("sanity check failed : invalid key\n");
		return 1;
	}
	printf("\a");
	return 0;
}

void
readdata (char *infile, int checkstub)
{
	FILE *fh;
	FILE *fh2;
	char *elffile;
	int i;
        unsigned long l, fnd;
	unsigned long fixup = 0;

	char sign[] = "TEEE burneye - TESO ELF Encryption Engine";

	/* the following hash matches with stub.standard */
	char knownstub[] =
	"\x66\xCC\x2F\x96\x65\x3D\x4E\x36\x4D\x37"
	"\x19\x20\x85\x8C\xAC\x91\x39\xDA\xFD\x88";

	/* this is the stub I've seen used in 7350buffalo
	   and 7350fun */
	char otherstub[] =
	"\xA7\x76\x2C\xFF\x09\x99\x6C\x22\xD7\x90"
	"\xB7\xD2\xB5\x71\x2C\xF6\xD3\x91\x30\x38";

	printf("---[ loading file data\n");
	if ((fh = fopen(infile, "rb")) == 0) {
		printf("failed to open file %s\n", infile);
	        exit(EXIT_FAILURE);
	}
	if ((elffile = (char *)malloc(0x5A00)) == 0) {
		printf("failed to allocate memory\n");
	        exit(EXIT_FAILURE);
	}
	fseek(fh, 0, SEEK_SET);
	fread(elffile, 1, 0x5A00, fh);
	fnd=0;
	for(l = 0; l < 0x5A00-sizeof(sign)+1; l++)
		if (memcmp(&elffile[l], sign, sizeof(sign)-1) == 0) {
			fnd=1;
			break;
		}
	if (fnd) {
		printf("burneye signature found @ %08lX\n", l);
	}
	printf("burneye stub hash :");
	SHA1Hash(elffile+l, 0x5A00-l, digest);
	for(i = 0; i < 20; i++)
		printf(" %02X", digest[i]);
	printf("\n");
	if (checkstub && !(!memcmp(knownstub, digest, 20) || !memcmp(otherstub, digest, 20))) {
		printf("unrecognized stub... are you sure it has layer 1 removed?\n");
		printf("dumping unknown stub to disk for analysis...\n");
		if ((fh2 = fopen("stub", "w")) == 0) {
			printf("failed to open file stub\n");
	    		exit(EXIT_FAILURE);
		}
    		fwrite(elffile+l, 1, 0x5A00-l, fh2);
		fclose(fh2);
		free(elffile);		
		exit(EXIT_FAILURE);
	}
	if (!memcmp(otherstub, digest, 20)) {
		printf("stub description  : alternative stub\n");
		fixup = 0x20;
	}
	free(elffile);
	fseek(fh, 0x5A00+FIXUP+fixup, SEEK_SET);
	fread(&l, 1, 4, fh);
	fread(&cryptedlength, 1, 4, fh);
	printf("encrypted length  : %ld\n", cryptedlength);
	fseek(fh, 0x5A00+l+FIXUP+fixup, SEEK_SET);
	cryptedstart = 0x5A00+l+FIXUP+fixup;	
	printf("encrypted start   : 0x%08lX\n", cryptedstart);
	fread(&crypted, 1, 4, fh);
	printf("encrypted dword   : 0x%08lX\n", crypted);
	crypted ^= 0x464C457F;
	fseek(fh, 0x5A00+l-0x28+FIXUP+fixup, SEEK_SET);
	fread(&checksum, 1, 4, fh);	
	printf("checksum          : 0x%08lX\n", checksum);
	fseek(fh, 0x5A00+l-0x24+FIXUP+fixup, SEEK_SET);
	printf("magic XOR block   :");
	fread(&xormagic, 1, 20, fh);	
	for(i = 0; i < 20; i++)
		printf(" %02X", xormagic[i]);
	printf("\n");
	fclose(fh);
}

void
gennextpwd(void)
{
	unsigned pwdind = 0;
	while(pwdind != pwdlen && pwdlen != 0) {
		if (pwd[pwdind] == endcharset) {
			pwd[pwdind] = startcharset;
			pwdind++;
		} else {
			pwd[pwdind]++;
			return;
		}
	}
	pwd[pwdlen] = startcharset;
	pwdlen++;
}

void
speedtest (void)
{
	int i, j;
	FILE * fh;
	FILE * fh2;
	char str[512];
	unsigned char resdigest[20] =
	"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
	"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";

	printf("---[ speed testing\n");
	if ((fh = fopen("speed.txt", "w")) == 0) {
		printf("failed to open file speed.txt\n");
	        exit(EXIT_FAILURE);
	}
	if ((fh2 = fopen("/proc/cpuinfo", "r")) == 0) {
		printf("failed to open file /proc/cpuinfo\n");
	        exit(EXIT_FAILURE);
	}
	fgets(str, 512, fh2);
	while(!feof(fh2)) {
    		if (strstr(str, "vendor_id") ||
    		    strstr(str, "model name") ||
		    strstr(str, "MHz")) {
			printf(str);
			fprintf(fh, str);
		}
		fgets(str, 512, fh2);
	}
	fclose(fh2);
	memset(str, 0, 512);
	for(i = 0; i < 128; i++) {
		str[i] = 'A';
		SHA1Hash(str, i+1, digest);
		for(j = 0; j < 20; j++)
			resdigest[j] ^= digest[j];
	}
	printf("hashing check   : ");	
	for(j = 0; j < 20; j++)
	    printf("%02X ", resdigest[j]);
	printf("\n");
	memset(pwd, 0, 64);
	memcpy(pwd, "speed", 6);
	pwdlen = strlen(pwd);
	gettimeofday(&todstart, &dummy);  
	for(j = 0; j < 2000000; j++)
		SHA1Hash(pwd, pwdlen, digest);
	gettimeofday(&todend, &dummy);
	starttime = ((double)todstart.tv_sec) + ((double)todstart.tv_usec / 1000000.);
	endtime = ((double)todend.tv_sec) + ((double)todend.tv_usec / 1000000.);
	printf("test password   : \"%s\"\n", pwd);
	printf("resulting hash  : ");
	for(j = 0; j < 20; j++)
	    printf("%02X ", digest[j]);
	printf("\n");
	printf("SHA1 hash speed : 2000000 hashes / %ld seconds (%ld hashes / sec)\n", (unsigned long)(endtime-starttime), (unsigned long)(2000000./(endtime-starttime)));
	fprintf(fh, "test password   : \"%s\"\n", pwd);
	fprintf(fh, "SHA1 hash speed : 2000000 hashes / %ld seconds (%ld hashes / sec)\n", (unsigned long)(endtime-starttime), (unsigned long)(2000000./(endtime-starttime))); 
	gettimeofday(&todstart, &dummy);  
	for(j = 0; j < 2000000; j++)
	        rc4check(digest, crypted);    
	gettimeofday(&todend, &dummy);
	starttime = ((double)todstart.tv_sec) + ((double)todstart.tv_usec / 1000000.);
	endtime = ((double)todend.tv_sec) + ((double)todend.tv_usec / 1000000.);
	printf("RC4 speed       : 2000000 checks / %ld seconds (%ld checks / sec)\n", (unsigned long)(endtime-starttime), (unsigned long)(2000000./(endtime-starttime)));
	fprintf(fh, "RC4 speed       : 2000000 checks / %ld seconds (%ld checks / sec)\n", (unsigned long)(endtime-starttime), (unsigned long)(2000000./(endtime-starttime)));
	gettimeofday(&todstart, &dummy);  
	for(j = 0; j < 1000000; j++) {
		SHA1Hash(pwd, pwdlen, digest);
		digest[0] ^= xormagic[0];
		digest[1] ^= xormagic[1];
		digest[2] ^= xormagic[2];
		digest[3] ^= xormagic[3];
		digest[4] ^= xormagic[4];
		digest[5] ^= xormagic[5];
		digest[6] ^= xormagic[6];
		digest[7] ^= xormagic[7];
		digest[8] ^= xormagic[8];
		digest[9] ^= xormagic[9];
		digest[10] ^= xormagic[10];
		digest[11] ^= xormagic[11];
		digest[12] ^= xormagic[12];
		digest[13] ^= xormagic[13];
		digest[14] ^= xormagic[14];
		digest[15] ^= xormagic[15];
	        digest[16] ^= xormagic[16];
	        digest[17] ^= xormagic[17];
	        digest[18] ^= xormagic[18];
	        digest[19] ^= xormagic[19];
	        SHA1Hash(digest, 20, digest);
	        rc4check(digest, crypted);
	        gennextpwd();
	}
	gettimeofday(&todend, &dummy);
	starttime = (todstart.tv_sec) + (todstart.tv_usec / 1000000.);
	endtime = (todend.tv_sec) + (todend.tv_usec / 1000000.);
	printf("combined cracking speed : 1000000 passwords / %ld seconds (%ld passwords / sec)\n", (unsigned long)(endtime-starttime), (unsigned long)(1000000/(endtime-starttime)));
	fprintf(fh, "combined cracking speed : 1000000 passwords / %ld seconds (%ld passwords / sec)\n---\n", (unsigned long)(endtime-starttime), (unsigned long)(1000000/(endtime-starttime)));
	printf("(you can append the results of this test (speed.txt) to results.txt)\n");
	fclose(fh);
}

int
bfcracker(char *infile)
{
	printf("---[ simple bruteforce cracker\n");
	time(&timestart);  
	goto crappycode;
	do {
		gennextpwd();
crappycode:

		/* the following informational code about the cracking process
		   doesn't really cause a significant change in the cracking
		   speed */
		if ((pwd[0] == startcharset) &&
		    (pwd[1] == startcharset) &&
		    (pwd[2] == startcharset) &&
		    (pwd[3] == startcharset))
			printf("????%s\n", pwd+4);

		SHA1Hash(pwd, pwdlen, digest);
	        digest[0] ^= xormagic[0];
		digest[1] ^= xormagic[1];
		digest[2] ^= xormagic[2];
	        digest[3] ^= xormagic[3];
	        digest[4] ^= xormagic[4];
	        digest[5] ^= xormagic[5];
	        digest[6] ^= xormagic[6];
	        digest[7] ^= xormagic[7];
	        digest[8] ^= xormagic[8];
	        digest[9] ^= xormagic[9];
	        digest[10] ^= xormagic[10];
	        digest[11] ^= xormagic[11];
	        digest[12] ^= xormagic[12];
	        digest[13] ^= xormagic[13];
	        digest[14] ^= xormagic[14];
	        digest[15] ^= xormagic[15];
	        digest[16] ^= xormagic[16];
	        digest[17] ^= xormagic[17];
	        digest[18] ^= xormagic[18];
	        digest[19] ^= xormagic[19];
	        SHA1Hash(digest, 20, digest);
        } while (!rc4check(digest, crypted));
        time(&timeend);
        if (rc4check(digest, crypted) != 0) {
		printf("\a");
	        printf("password \"%s\" okay! cracked in %ld seconds.\n",
			pwd, timeend-timestart);
		if (sanitycheck(infile)) {
			printf("sanity check failed! bruteforce continues...\n");
			gennextpwd();
			goto crappycode;
		}
		return 0;
        }
	return -1;
}

int
stdincracker(char *infile)
{
	printf("---[ stdin bruteforce cracker\n");
	time(&timestart);  
	memset(pwd, 0, 64);
	fgets(pwd, 64, stdin);
	while (!feof(stdin)) {
		pwdlen = strlen(pwd);
		while(pwd[pwdlen-1] == '\n')
			pwd[--pwdlen] = '\x00';
		SHA1Hash(pwd, strlen(pwd), digest);
	        digest[0] ^= xormagic[0];
		digest[1] ^= xormagic[1];
		digest[2] ^= xormagic[2];
	        digest[3] ^= xormagic[3];
	        digest[4] ^= xormagic[4];
	        digest[5] ^= xormagic[5];
	        digest[6] ^= xormagic[6];
	        digest[7] ^= xormagic[7];
	        digest[8] ^= xormagic[8];
	        digest[9] ^= xormagic[9];
	        digest[10] ^= xormagic[10];
	        digest[11] ^= xormagic[11];
	        digest[12] ^= xormagic[12];
	        digest[13] ^= xormagic[13];
	        digest[14] ^= xormagic[14];
	        digest[15] ^= xormagic[15];
	        digest[16] ^= xormagic[16];
	        digest[17] ^= xormagic[17];
	        digest[18] ^= xormagic[18];
	        digest[19] ^= xormagic[19];
	        SHA1Hash(digest, 20, digest);
		if (rc4check(digest, crypted))
			break;
crappycode2:
		fgets(pwd, 64, stdin);
        }
        time(&timeend);
        if (rc4check(digest, crypted) != 0) {
		printf("\a");	
	        printf("password \"%s\" okay! cracked in %ld seconds.\n",
			pwd, timeend-timestart);
		if (sanitycheck(infile)) {
			printf("sanity check failed! bruteforce continues...\n");
			goto crappycode2;
		}
		return 0;
        }
	return -1;
}

int
checkpwd(char *infile)
{
	printf("---[ checking password \"%s\"\n", pwd);
	SHA1Hash(pwd, pwdlen, digest);
        digest[0] ^= xormagic[0];
	digest[1] ^= xormagic[1];
	digest[2] ^= xormagic[2];
        digest[3] ^= xormagic[3];
        digest[4] ^= xormagic[4];
        digest[5] ^= xormagic[5];
        digest[6] ^= xormagic[6];
        digest[7] ^= xormagic[7];
        digest[8] ^= xormagic[8];
        digest[9] ^= xormagic[9];
        digest[10] ^= xormagic[10];
        digest[11] ^= xormagic[11];
        digest[12] ^= xormagic[12];
        digest[13] ^= xormagic[13];
        digest[14] ^= xormagic[14];
        digest[15] ^= xormagic[15];
        digest[16] ^= xormagic[16];
        digest[17] ^= xormagic[17];
        digest[18] ^= xormagic[18];
        digest[19] ^= xormagic[19];
        SHA1Hash(digest, 20, digest);
        if ((rc4check(digest, crypted) != 0) && !sanitycheck(infile)) {
	        printf("password \"%s\" okay!\n", pwd);
		return 0;
        } else {
		printf("password \"%s\" incorrect... :(\n", pwd);
		return -1;
	}
}

/* dumpfile will decrypt infile with layer 1 removed to outfile
   using the digest of the correct password */
void
dumpfile(char *infile, char *outfile)
{
	FILE * fh;
	rc4_key key;
	char * elffile;
	printf("---[ dumping wrapped binary\n");
	if ((fh = fopen(infile, "rb")) == 0) {
		printf("failed to open file %s\n", infile);
	        exit(EXIT_FAILURE);
	}
	printf("start of binary : %08lX\n", cryptedstart);
	printf("binary filesize : %ld\n", cryptedlength);
	if ((elffile = (char *)malloc(cryptedlength)) == 0) {
		printf("failed to allocate memory\n");
	        exit(EXIT_FAILURE);
	}
	fseek(fh, cryptedstart, SEEK_SET);
	fread(elffile, 1, cryptedlength, fh);
	fclose(fh);
	if (crypted) {
    		prepare_key(digest, 20, &key);
    		rc4(elffile, cryptedlength, &key);
	}
	if ((fh = fopen(outfile, "w")) == 0) {
		printf("failed to open file %s\n", infile);
	        exit(EXIT_FAILURE);
	}
        fwrite(elffile, 1, cryptedlength, fh);
	fclose(fh);
	free(elffile);
	printf("\"%s\" written!\n", outfile);
}

void
usage (char *progname)
{
	fprintf (stderr, "usage: %s [-h] [-s] [-n] [-b lower|upper|digits] [-i] [-p <password>] [-f <filename>] [-d <filename>]\n\n", progname);
	
	fprintf (stderr,
		"-h\t\tthis help\n"
		"-s\t\tdo a speedtest\n"
		"-f filename\tfile to crack\n"
		"-n\t\tperform no checking of the burneye stub\n"
		"-b charset\ttry lower- / uppercase alpha / digits bruteforce\n"
		"-i\t\ttry bruteforce via stdin\n"
		"-p password\ttry the given password\n"		
		"-d filename\tdump output to this file (default: not dumped)\n\n");
		
	exit (EXIT_FAILURE);
}
 
int
main(int argc, char ** argv)
{
	char c;
	char *progname;

	int speedcheck = 0;
	int bruteforce = 0;
	int usestdin = 0;
	int usepwd = 0;
	int checkstub = 1;

        fprintf(stderr, "UNFburninhell by [ByteRage] / UNF\n\n");
    
        progname = argv[0];
        if (argc < 2)
    		usage(progname);

	/* the -p switch overwrites where bruteforcing should start */
	memcpy(pwd, "a", 2);
	pwdlen = 1;

	while ((c = getopt (argc, argv, "hsb:inf:d:p:")) != EOF) {
		switch(c) {
		case 'h':
			usage (progname);
			break;
		case 's':
			speedcheck = 1;
			break;
		case 'b':
			bruteforce = 1;
			if (!memcmp(optarg, "upper", 6)) {
				startcharset = 'A';
				endcharset = 'Z';
				memcpy(pwd, "A", 2);
				pwdlen = 1;
			} else if (!memcmp(optarg, "digits", 6)) {
				startcharset = '0';
				endcharset = '9';
				memcpy(pwd, "0", 2);
				pwdlen = 1;
			}
			break;
		case 'i':
			usestdin = 1;
			break;
		case 'n':
			checkstub = 0;
     			break;
		case 'f':
			infile = optarg;
     			break;
		case 'd':
			outfile = optarg;
     			break;
		case 'p':
			usepwd = 1;
			memcpy(pwd, optarg, strlen(optarg)+1);
			pwdlen = strlen(pwd);
     			break;
		default:
			usage (progname);
			break;
		}
	}

	if (speedcheck) {

		speedtest();

	} else {

		if (usestdin)
			bruteforce = 0;

		if (usepwd)
			usestdin = 0;

		if (bruteforce)
			usepwd = 0;

		if (infile[0] != 0)
			removelayer1(infile);

		readdata(intermediatefile, checkstub);

		if (!crypted) {
			if (outfile[0] != 0)
				dumpfile(intermediatefile, outfile);
		}

		if (crypted && usepwd) {
			if (!checkpwd(intermediatefile)) {
				if (outfile[0] != 0)
					dumpfile(intermediatefile, outfile);
			}
		}
	
		if (crypted && bruteforce) {
			if (!bfcracker(intermediatefile)) {
				if (outfile[0] != 0)
					dumpfile(intermediatefile, outfile);
			}
		}

		if (crypted && usestdin) {
			if (!stdincracker(intermediatefile)) {
				if (outfile[0] != 0)
					dumpfile(intermediatefile, outfile);
			}
		}

	}	

	printf("---[ bailing out\n\n");
	return 0;
}